from System.Collections.Generic import List
from System import Byte, Int32
import sys
#
# Set this to the exact name of your pick script .. capital matters
# and it has to be in your list of scripts on UI
#
#
# First keep track of position in book 
#
RuneBook = 0x4017B80D
if Player.Name == "Greed":
    RuneBook = 0x4225978D
#
#
# Next keep track of position in book. At end of a book we'll set next book 
#
RuneOrder = [ 7, 13, 19, 25, 31, 37, 43, 49, 55, 61] #, 59, 65, 71, 77, 83, 95 ] 
#
# A function I'll need later to check if runbook entry is Empty
#
def RuneBookFirstNameIndex():    
    gumpList = Gumps.LastGumpGetLineList()
    textParts = ["Charges:", "Max Charges:", "Rename book", "Drop rune", 
                 "Set default", "Recall", "Gate Travel", "Sacred Journey" ]
    index = 0
    #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
    while gumpList[index].strip() in textParts:
        #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
        index = index + 1
        # now index should be at the charges numbers so skip 1 more
    index = index + 2
    #Misc.SendMessage("Starts at: {}".format(index))
    return index

def DistanceTo(x, y):
    return (((Player.Position.X - x)**2) + ((Player.Position.Y - y)**2))**.5
    
def TransportToRuneIndex(RuneIndex):
    Gumps.ResetGump()
    bookOpen = False
    while not bookOpen:
        Items.UseItem(RuneBook)
        Gumps.WaitForGump(Gumps.CurrentGump(), 1000)
        if Gumps.HasGump():
            bookOpen = True
    #        
    bookSlotName = Gumps.LastGumpGetLine(RuneBookFirstNameIndex()+RuneIndex)
    Misc.SendMessage(bookSlotName.strip().lower()) 
    if bookSlotName.strip().lower() != "empty":
        Gumps.SendAction(Gumps.CurrentGump(), RuneOrder[RuneIndex])
    Misc.Resync()
    Misc.Pause(5000)

    
def kill(name):
    while True:
        filter = Mobiles.Filter()
        filter.Name = name
        filter.RangeMax = 20
        mobs = Mobiles.ApplyFilter(filter)
        if len(mobs) > 0:
            #Player.SetWarMode(True)
            mob = mobs[0]       
            if Player.ManaMax > 162:
                if Player.DistanceTo(mob) > 8:
                    route = PathFinding.Route()
                    route.X = mob.Position.X+5
                    route.Y = mob.Position.Y-5
                    route.UseResync = False
                    route.MaxRetry = 2
                    PathFinding.Go(route)
                Spells.CastMagery("Energy Bolt", mob)
                Misc.Pause(2500)                                     
            else:
                if Player.DistanceTo(mob) > 2:
                    route = PathFinding.Route()
                    route.X = mob.Position.X
                    route.Y = mob.Position.Y
                    route.UseResync = False
                    route.MaxRetry = 2
                    PathFinding.Go(route)                
                Player.Attack(mob)    
        else:
            break
        Misc.Pause(1000)    
    Player.SetWarMode(False)        
                
def get_quest():
    Samus = Mobiles.FindBySerial(0x00000D05) 
    Misc.SendMessage("Should get Quest")
    if Player.DistanceTo(Samus) > 2:
        Player.PathFindTo(Samus.Position.X, Samus.Position.Y, Samus.Position.Z)
        while Player.DistanceTo(Samus) > 2:
            Misc.Pause(1000)
    noQuest = True
    while noQuest:
        Journal.Clear()        
        Misc.WaitForContext(Samus, 2000)
        Misc.ContextReply(Samus, "Talk")
        Misc.Pause(1000)
        if Journal.Search("check back"):
            noQuest = True
            Player.UseSkill("Hiding")
            Misc.Pause(5*60000)
        elif Journal.Search("Talk not exist"):
            noQuest = True
            Misc.Pause(1000)
            continue
        else:
            noQuest = False                
    Gumps.WaitForGump(0, 1000)
    if Gumps.LastGumpTextExist("Bah your worthless"):
        Gumps.SendAction(0, 0)
    elif Gumps.LastGumpTextExist("Quest Offer"):
        Gumps.SendAction(0, 4)    

def get_yeast():
    Misc.SendMessage("Kill the Farmer")
    kill("Hayden Failstor")
    
def attack_blood_lich():
    Misc.SendMessage("Kill BloodLich")
    kill("a blood lich")

def kill_Yoshimitsu():
    kill("Yoshimitsu")
    
def kill_Bacchus():    
    kill("Bacchus")
    
    
def first_meeting_vincent():
    Vincent = Mobiles.FindBySerial(0x00000D0C)       
    Misc.Pause(2000)    
    Misc.SendMessage("Talk to Vincent first time")
    
    if Player.DistanceTo(Vincent) > 2:
        Player.PathFindTo(Vincent.Position.X, Vincent.Position.Y, Vincent.Position.Z)
        while Player.DistanceTo(Vincent) > 2:
            Misc.Pause(1000)        
    Misc.WaitForContext(Vincent, 2000)
    Misc.ContextReply(Vincent, "Talk")
    Misc.Pause(3000)
    
def meet_linda():
    Misc.SendMessage("Meet Linda")
    Misc.Pause(2000)    
    Linda = Mobiles.FindBySerial(0x00000D11)
    if Player.DistanceTo(Linda) > 2:
        Player.PathFindTo(Linda.Position.X, Linda.Position.Y, Linda.Position.Z)
        while Player.DistanceTo(Linda) > 2:
            Misc.Pause(1000)
    Misc.WaitForContext(Linda, 2000)
    Misc.ContextReply(Linda, "Talk")            
    Misc.Pause(2000)        
    
    
def second_meeting_vincent():
    Vincent = Mobiles.FindBySerial(0x00000D0C)  
    Misc.Pause(2000)    
    Misc.SendMessage("Talk to Vincent second time")
    if Player.DistanceTo(Vincent) > 2:
        Player.PathFindTo(Vincent.Position.X, Vincent.Position.Y, Vincent.Position.Z)
        while Player.DistanceTo(questGiver) > 2:
            Misc.Pause(1000)
    Misc.WaitForContext(Vincent, 3000)
    Misc.ContextReply(Vincent, "Talk")
    Misc.Pause(2000)
    Items.WaitForContents(Player.Backpack, 3000)
    
def mark_quest_item():    
    questItem = Items.FindByID (0x09A1, 0, Player.Backpack.Serial)
    if questItem != None:
        Misc.WaitForContext(Player.Serial, 2000)
        Misc.ContextReply(Player.Serial, "Toggle Quest Item")
        Target.WaitForTarget(3000)
        Misc.Pause(1000)
        Target.TargetExecute(questItem.Serial)
        Target.Cancel()
        Misc.SendToClient("{ESC}\n")

def finish_quest():
    Misc.SendMessage("Should get Quest")
    questGiver = Mobiles.FindBySerial(0x00000D05)
    if Player.DistanceTo(questGiver) > 2:
        Player.PathFindTo(questGiver.Position.X, questGiver.Position.Y, questGiver.Position.Z)
        while Player.DistanceTo(questGiver) > 2:
            Misc.Pause(1000)
    Misc.WaitForContext(questGiver, 3000)
    Misc.ContextReply(questGiver, "Talk")
    Gumps.WaitForGump(0, 5000)
    Gumps.SendAction(0, 8)
    Gumps.WaitForGump(0, 5000)
    Gumps.SendAction(0, 5)    
#        
#
# Now finally everything is set. 
#
#
# RuneBookIndex is set to the current book to use
# RuneIndex is set to which rune in that book to use

Action = [ [get_quest, 0x0 ], 
    [get_yeast, 0x1039], 
    [kill_Yoshimitsu, 0x0E2A], 
    [attack_blood_lich, 0x1025], 
    [kill_Bacchus, 0x09C8], 
    [first_meeting_vincent, 0x1039], 
    [meet_linda, 0x0FF4],
    [second_meeting_vincent, 0x1039],
    [mark_quest_item, 0x09A1],
    [finish_quest, 0x1039],         
    ]
    
state = 0
while state != len(Action):
    if Items.FindByID(0x0FF3, -1, Player.Backpack.Serial) != None:
        state = 6
    if Items.FindByID(0x0FF4, -1, Player.Backpack.Serial) != None:
        state = 7  
    if Items.FindByID(0x09A1, 0, Player.Backpack.Serial) != None:
        state = 8  
    if Items.FindByID(0x09A1, 0x04ea, Player.Backpack.Serial) != None:
        state = 9  
    #    
    if state == 0:
        if DistanceTo(1347, 1499) > 2:        
            TransportToRuneIndex(state)
        Action[state][0]()
        state = state + 1
    while state >= 1 and state <= 4:
        if Items.FindByID(Action[state][1], -1, Player.Backpack.Serial) == None:
            Misc.SendMessage("taking action for state: {}".format(state))
            TransportToRuneIndex(state)
            Action[state][0]()
        else:
            Misc.SendMessage("incrementing state: {}".format(state))
        state = state + 1
        Misc.Pause(1000)
    if state == 5:
        if Items.FindByID(0x0FF3, -1, Player.Backpack.Serial) == None:
            Misc.SendMessage("Talk to Vincent #1")
            if DistanceTo(1545, 1768) > 2:        
                TransportToRuneIndex(state)
            Action[state][0]()
        state = state + 1
    if state == 6:
        if Items.FindByID(Action[state][1], -1, Player.Backpack.Serial) == None:
            Misc.SendMessage("taking action for state: {}".format(state))
            TransportToRuneIndex(state)
            Action[state][0]()
        else:
            Misc.SendMessage("incrementing state: {}".format(state))
        state = state + 1
        Misc.Pause(1000)  
    if state == 7:
        if Items.FindByID(0x0FF3, 0, Player.Backpack.Serial) == None:
            Misc.SendMessage("Talk to Vincent #2")
            if DistanceTo(1545, 1768) > 2:        
                TransportToRuneIndex(state)
            Action[state][0]()
        state = state + 1
    if state == 8:
        if Items.FindByID(0x0FF3, -1, Player.Backpack.Serial) == None:
            Misc.SendMessage("Mark Quest Item")
            Action[state][0]()
        state = state + 1
    if state == 9:
        if DistanceTo(1347, 1499) > 2:        
            TransportToRuneIndex(8)
        Action[state][0]()
        state = state + 1
        Misc.Pause(1000)
    # 
    TransportToRuneIndex(9)
    Misc.Pause(29*60000)
    
    

